#include <stdio>
#include <vector>
#include <string>
#include <fstream>
#include "lib/helper/ini.h"

#define MAX_Zeilen_Laenge 1024
#define ERROR -1

void cIniFile::LoadIni(char *filename)
{
  FILE *handle;
  bChanged=false;

  char zeile[MAX_Zeilen_Laenge];
  if((handle = fopen(filename,"rb")) == NULL)
  {
    printf("\"%s\" konnte nicht geffnet werden!",filename);
    return;
  }
  while (!feof(handle))
  {
    if (fgets(zeile,MAX_Zeilen_Laenge,handle)!=NULL)
    {
       if (zeile[strlen(zeile)-1]==10) zeile[strlen(zeile)-1]=0;
       if (zeile[strlen(zeile)-1]==13) zeile[strlen(zeile)-1]=0;
       if (strlen(zeile)>0)
       {
       	m_Array.insert(m_Array.end(),zeile);
       }
       else
       {
       	m_Array.insert(m_Array.end()," ");
       }
    }
  }
  fclose(handle);
}

void cIniFile::WriteIni(char *filename)
{
  FILE *handle;

  if (!bChanged) return;
  bChanged=false;
  if((handle = fopen(filename,"w+")) == NULL)
  {
    printf("\"%s\" konnte nicht geffnet werden!",filename);
    return;
  }

  for (vector<string>::iterator i=m_Array.begin(); i<m_Array.end();i++)
  {
  		fprintf(handle,"%s\n",*i);
      //fprintf(handle,"\n");
  }
  fclose(handle);
}

string cIniFile::ReadKey(string section, string sKey)
{
  int i;

  i=FindKey(section, sKey);
  if (i==ERROR) return "";
  return ExtractValue(i);
}

int cIniFile::FindSection(string section)
{
  int i=0;

  if (m_Array.size()==0) return ERROR;

  while (m_Array[i]!=string("["+section+"]"))
  {
     i++;
	  if (i>m_Array.size()-1) return ERROR;
  }
  return i;
}

int cIniFile::FindKey(string section, string sKey)
{
  int i=0;

  i=FindSection(section);
  if (i==ERROR) return ERROR;

  while (KeyWord(m_Array[i])!=sKey)
  {
     i++;
	  if (i>m_Array.size()-1) return ERROR;
     if (m_Array[i][0]=='[') return ERROR;
  }
  return i;
}

string cIniFile::ExtractValue(int i)
{
  int pos=m_Array[i].find("=")+1;
  return m_Array[i].substr(pos,m_Array[i].length()-pos);
}

string cIniFile::KeyWord(string s)
{
  int pos;
  pos=s.find("=");
  if (pos<0) return "";
  return s.substr(0,pos);
}

void cIniFile::WriteKey(string section, string sKey, string value)
{
   int line;

   bChanged=true;

   if ((line=FindKey(section,sKey))!=ERROR)
   {
		m_Array[line]=string(sKey+'='+value);
   }
	else if ((line=FindSection(section))!=ERROR)
   {
      m_Array.insert(m_Array.begin()+line+1,string(sKey+'='+value));
   }
   else
   {
      m_Array.insert(m_Array.end(),string("["+section+"]"));
      m_Array.insert(m_Array.end(),string(sKey+'='+value));
   }
}

int cIniFile::ReadKeyI(string sSection, string sKey, int iDefault)
{
   string sValue;
   int result;
	sValue=ReadKey(sSection, sKey);
   if (sValue.length()!=0)
   {
   	result=atoi(sValue.c_str());
   }
   else
   {
   	result=iDefault;
   }
   return result;
}

void cIniFile::WriteKeyI(string sSection, string sKey, int iValue)
{
   char sValue[17];
	WriteKey(sSection, sKey, itoa(iValue,sValue,10));
}

unsigned long cIniFile::ReadKeyHex(string sSection, string sKey, int iDefault)
{
   string sValue;
   unsigned long result;
	sValue=ReadKey(sSection, sKey);
   if (sValue.length()!=0)
   {
      sscanf(sValue.c_str(),"%lx",&result);
   }
   else
   {
      printf("Key [%s] not found in INI-File\n",sKey);
   	result=iDefault;
   }
   return result;
}
