/*  mp3player hardware test

    15.05.2001: tk, initial implementation.

    Copyright (c)2000 by Thomas Kindler, thomas.kindler@gmx.de

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version. Read the
    full License at http://www.gnu.org/copyleft for more details.
*/

/*
todo
Bufferunderrun! Einfach Buffer zurcksetzen; vs1001 neu initialisieren; siehe NEWSGROUP
CommandQueue Einrichen (bersetzt Ereignisse von Tastatur, RC, etc. in einheiliches Format); Kann als Ringbuffer ausgefhrt werden
Anzeige der Nummer des Songs <setzt neue Implementierung der Songliste voraus>
Mglichkeit, einen Song mit der Songnummer anzusteuern (Wie bei CD-Player)
Volume/Dimmer in 10% Schritten
Entsprellen der Fernsteuerung
Playlisten (M3U)
Pause zwischen Stcken
RC-Codes in ini-Datei auslagern
Tastenfunktionen so umschreiben, da sowohl keyboard, RC, Playertasten untersttzen
Random-Funktion (evt. mu in Playlist eintrag ob Song schon gespielt)
Playlist in ein Objekt umwandeln. Sinnvoll um Stabilitt Programm zu erhhen
Sprachresourcen auslagern
*/


/*
Verbesserungen/Bug-Fixes:
06.02.02
1. Wenn in Songliste wird Rechenzeit freigegeben
2. Scrollbox in Songliste verbessert (Scrollen des Balkens)
3. Wie bei CD-Spieler wird automatisch nchster Song weitergespielt
4. TestFile in PlaySong umbenannt
5. PlaySong hat Rckgabewert (wichtig um zu bestimmen ob STOP-Taste gedrckt wurde)
6. PlaySong kennt nunmehr Stop, Next, Prev, Play - Taste
7. Dimmer Funktion eingefgt zur Steuerung der Helligkeit des Displays
+++
07.02.02
8. Repeat1/Repeat all implementiert
9. Wenn letzter Eintrag erreicht, dann auf ersten springen usw.
10. Startparameter gendert:
    kein Argument, dann CD-Player Mode
    /wr WebRadio starten
    dateiname spielt nur datei ab
11. Pausen-Funktion implementiert
12. Fortschrittsanzeige und Zeitanzeige in einer Zeile miteinander kombiniert
13. Untersttzung von Verzeichnissen
+++
08.02.2002
14. BEHOBEN: Player strzt ab, wenn bei letzen Song next gedrckt wird (
    hngt mit Verzeichnissen zusammen)
15. BEHOBEN: Repeat 1/All wird in falscher Zeile angezeigt
16. BEHOBEN: Wenn < 4 Eintrge fehlerhafte Darstellung
+++
09.02.2002
17. Bei ersten Anzeigen eines Liste immer auf erstes spielbares Lied springen
18. -----------------------
19. V_KEYs eingefhrt
+++
10.02.2002
20. Volume Werte nicht mehr nach jedem neuen Song zurcksetzen
23. Anzeige eines Pop-Fensters wenn Pause
24. Anzeigen eines Volume-Fensters bei verndern der Lautstrke
25. Wenn kein Artist, wird Songtitel/Filename in 1. Zeile angezeigt
26. Speichern der Lautstrkeeinstellung
27. Player automatisch starten (autostart eines best albums) (in mp3.ini Sektion "SETTINGS",
    Key "AUTOPLAY" jeweilige Verzeichnis angeben)
28. Bei ndern der Dimmereinstellungen, diese im Fenster anzeigen (BAR + Prozent)
29. Speichern der Dimmereinstellung 
*/

// include files -----
//
#include <fstream>
#include <string>

#include <alloc.h>
#include <stdio.h>
#include <dos.h>
#include <dir.h>
#include <io.h>
#include <time.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include "lib/sc12/amd186.h"
#include "lib/sc12/rtos.h"
#include "lib/sc12/hwapi.h"
#include "lib/helper/checkbios.h"
#include "lib/helper/ztimer.h"
#include "lib/video/lcd.h"
#include "lib/remote/remote.h"
#include "lib/video/gfxlcd.h"
#include "lib/audio/id3v1.h"
#include "lib/audio/vs1001.h"
#include "lib/helper/misc.h"
#include "lib/inet/httpget.h"
#include "lib/inet/url.h"
#include "lib/audio/mpbuf.h"
#include "lib/audio/mpeg.h"
#include "lib/helper/readline.h"
#include "lib/video/lcd_win.h"
#include "lib/helper/ini.cpp"
#include "lib/messages/messages.h"

static BitmapFont  *bigfont, *smallfont;
static int Brightness;
static int iRepeat;
unsigned long lastkey =0;
int  vol        = 196;
cIniFile ini;
CommandMessages msgs;
int   numPlaylistEntries = 0;
int   numSongs = 1;


#define INI_FILE "a:\mp3.ini"

#define cPlaylistMaxEntries 256

#define cNoRepeat  0
#define cRepeatOne 1
#define cRepeatAll 2

#define cOK      0
#define cError  -1
#define cStop   -2
#define cPrev   -3
#define cNext   -4
#define cReplay -5

#define CONST_MP3 'C'
#define CONST_Dir 'D'
#define CONST_M3U 'L'

int IsM3U(char *cDir);
void ReadDirectory(char *cDir);
void ReadM3U(char *filename);

void WebRadio()
{
  for(;;) {
    char str[80];
    printf("enter URL: ");
    readline(str, sizeof(str));
    printf("\n");
    if (strlen(str) == 0)
      break;
    http_get(str);
  }
}


/// \bug  divide by zero on 0-length files
int PlaySong(char *filename, int iSongNo)
{
  int result = cOK;
  int next_song=0;
  time_t zeit, cur_zeit;
  zeit=0;

  VS_SetVolume(vol, vol);

  FILE *f = fopen(filename, "rb");
  if (!f) {
    perror("");
    return cError;
  }

  ID3v1Tag  tag;
  char title[128];
  if (ID3v1_ReadTag(f, &tag))
    //sprintf( title, "%s - %s (%s)", tag.artist, tag.title, tag.comment );
    sprintf( title, "%s", tag.title);
  else
    strncpy( title, filename, sizeof(title) );

  int  titlepos   =   0;
  int  titledir   =  -1;
  int  titlewidth = textwidth(title);
  if (titlewidth <= 122)
    titledir = 0;

  VS_Reset();
  BUF_Play();
  while (!(feof(f) && BUF_GetState() == BUF_STALLED))
  {
    // Read data from mp3 file
    //
    long  len, len1,  len2;
    char *buf1, *buf2;

    BUF_Lock( -1, min(16384L, BUF_GetFreeBytes()),
              &buf1, &len1, &buf2, &len2 );
    len = fread(buf1, 1, len1, f);
    if (buf2)
      len += fread(buf2, 1, len2, f);
    BUF_Unlock(len);

    // Update LCD display
    //
    cleardevice();
    titlepos += titledir;
    if (titlepos > 0)
      titledir = -1;
    if (titledir && (-titlepos > titlewidth-122))
      titledir =  1;
	 setfont(smallfont);
    outtextxy( 0, 0, tag.artist);
    setfont(bigfont);
    if (strlen(tag.artist)==0)
    {
	    outtextxy( titlepos, 0, title );
    }
    else
    {
	    outtextxy( titlepos, 8, title );
    }

    unsigned long header;
    FrameInfo     info;

    VS_GetMPEGHeader(&header);
    MPEG_ParseHeader(header, &info);

    setfont(smallfont);
    moveto(0, 16);
    //gprintf(MPEG_HeaderToString(header));

    long tell = ftell(f);
    long size = filelength(fileno(f));

    setfillstyle(SOLID_FILL, 1);
	 //line( 0, 24, 122, 24);
    rectangle(0, 23, 121, 31);
    bar( 1, 24, 2+(float)tell/(float)size*119.0, 30 );

    long bytepersec = info.bitrate/8;
    if (bytepersec > 0)
    {
      static char buf[1024];
      sprintf(buf, "%ld:%02ld/%ld:%02ld",
           (tell/bytepersec/60), (tell/bytepersec)%60,
           (size/bytepersec/60), (size/bytepersec)%60
         );

      outtextxy( (122-textwidth(buf)) / 2, 25, buf);
    }

    //Gebe SongNr aus
    static char buf[1024];
    setfont(bigfont);
	 sprintf(buf, "[%i]",iSongNo);
    outtextxy(4,25,buf);

    //Gebe aus wenn Repeat 1/All
    setfont(smallfont);
    switch (iRepeat)
    {
      case cRepeatOne:
      	outtextxy(0,16,"Repeat 1");
      	break;
      case cRepeatAll:
      	outtextxy(0,16,"Repeat All");
      	break;
      default:
    		break;
    }
    size = BUF_GetSize();
    tell = BUF_GetCount();
    //line( 0, 22, 2+(float)tell/(float)size*119.0, 22 );

    setfont(bigfont);
	 if (BUF_GetState() != BUF_PLAYING) ShowMessage("Pause");

    time(&cur_zeit);
    if (difftime(cur_zeit,zeit)<=2)
    {
      switch (lastkey)
      {
      	case VK_VOLUME_UP:
         case VK_VOLUME_DOWN:
	      	DrawVolumeBox((vol-127)*100/128);
            break;
         case VK_DIMMER:
      		DrawDimmerBox((Brightness*100/256)+1);
            break;
			case VK_0:
			case VK_1:
			case VK_2:
			case VK_3:
			case VK_4:
			case VK_5:
			case VK_6:
			case VK_7:
			case VK_8:
			case VK_9:
      		ShowJumpToWindow(next_song);
            break;
      }
    }
    else if (next_song>0)
    {
       BUF_Clear();
       result = next_song;
       goto Exit;
    }
    LCD_Update();

    // Process user input
    //
    if (kbhit())
    {
    	BUF_Clear;
      goto Exit;
    }
    while (msgs.Count())
    {
      int key = msgs.Get();
      switch (key)
      {
        case VK_DIMMER:
           Brightness+=16;
           if (Brightness >= 256)
           {
             Brightness=0;
           }
           ini.WriteKeyI("SETTINGS","BRIGHTNESS",Brightness);
           LCD_SetBrightness(Brightness);
           lastkey=VK_DIMMER;
           time(&zeit);
           break;

        // stop
        case VK_STOP:
          BUF_Clear();
          result = cStop;
          goto Exit;

        // FAST REWIND
        case  VK_FAST_REWIND:
          BUF_Clear(); BUF_Play();
          VS_Reset();
          fseek(f, -filelength(fileno(f))/20, SEEK_CUR);
          break;

        // FAST FORWARD
        case  VK_FAST_FORWARD:
          BUF_Clear(); BUF_Play();
          VS_Reset();
          fseek(f, filelength(fileno(f))/20, SEEK_CUR);
          break;

        //Prev Song
        case VK_PREV:
          BUF_Clear();
          result = cPrev;
          goto Exit;

        //Next Song
        case VK_NEXT:
          BUF_Clear();
          result = cNext;
          goto Exit;

        //Replay Song
        case VK_PLAY:
          BUF_Clear();
          result = cReplay;
          goto Exit;


		  // VOLUME DOWN
        case VK_VOLUME_DOWN:
          vol-=4;
          if (vol<128) vol = 128;
          VS_SetVolume(vol, vol);
          ini.WriteKeyI("SETTINGS","VOLUME",vol);
          lastkey=VK_VOLUME_DOWN;
          time(&zeit);
          break;

		  // VOLUME UP
        case VK_VOLUME_UP:
          vol+=4;
          if (vol>255) vol = 255;
          VS_SetVolume(vol, vol);
          ini.WriteKeyI("SETTINGS","VOLUME",vol);
          lastkey=VK_VOLUME_UP;
          time(&zeit);
          break;

        //REPEAT 1/All
        case VK_REPEAT:
        	 iRepeat++;
          iRepeat%=3;
          break;

        //Pause
		  case VK_PAUSE:
           if (BUF_GetState() == BUF_PLAYING)
             BUF_Stop();
           else
             BUF_Play();
           break;

        //VK_1
			case VK_0:
			case VK_1:
			case VK_2:
			case VK_3:
			case VK_4:
			case VK_5:
			case VK_6:
			case VK_7:
			case VK_8:
			case VK_9:
			next_song=next_song*10+key-VK_0;
			if ((next_song>=numSongs) || (next_song==0))
         {
           next_song=0;
           lastkey=0;
         }
         else
         {
         	lastkey=key;
         	time(&zeit);
         }
        	break;

        default:
          printf("VK_KEY [%i] not supported", key);
          break;
      }
   }

    // be nice to other apps
    //
    RTX_Sleep_Time(100);
  }

Exit:
  fclose(f);
  return result;
}


struct {
  int nr;
  char type;
  char *filename;
  char *title;
  bool played;  //Fr Random Funktion
} playlist[cPlaylistMaxEntries] = {0};


void Songlist()
{
  char *directory;
  char buffer[MAXPATH];

  iRepeat = cNoRepeat;

  //Goto Target Dir
  getcwd(buffer,MAXPATH);

  if (ini.ReadKey("SETTINGS","AUTOPLAY").length()>0)
  {
    directory=strdup(ini.ReadKey("SETTINGS","AUTOPLAY").c_str());
    msgs.Put(VK_PLAY);
  }
  else
  {
    directory=strdup(buffer);
  }
LoadDir:
	//Verzeichnisbaum aufrumen
   for (int i=0;i<numPlaylistEntries;i++)
   {
    free(playlist[i].filename);
    free(playlist[i].title);
   }
   numPlaylistEntries=0;
   numSongs=1;

   if (IsM3U(directory))
   {
   	ReadM3U(directory);
   }
   else
   {
		ReadDirectory(directory);
   }

//Startwerte Playlistanzeige
  int currentSong = 0;
  int PosBar = 0;


// Bewege Anzeige auf erstes spielbares Lied (damit man dierekt PLAY drcken kann)
	for (int i=0;i<numPlaylistEntries-1;i++)
   {
      if (playlist[currentSong].type == CONST_MP3)
      {
      	break;
      }
      currentSong++;
      if (PosBar>0) PosBar--;
      if (PosBar<3) PosBar++;
   }
   if (playlist[currentSong].type != CONST_MP3)
   {
      PosBar=0;
      currentSong=0;
   }


// Zeige Playlist an
  for(;;)
  {
    int iResult;
    cleardevice();
    int j = currentSong;
    for (int i=0; i<4; i++)
    {
      moveto(1, i*8+1);
      if (i+j-PosBar < numPlaylistEntries) {
        if (i==PosBar)
        {
          setfillstyle(SOLID_FILL, 1);
          bar(0,i*8,121,(i*8)+7);
        }
        setfont(bigfont);
        if (playlist[i+j-PosBar].type == CONST_Dir)
        {
        	  setfont(smallfont);
			  gprintf("<DIR> ");
           setfont(bigfont);
        }
        else if (playlist[i+j-PosBar].type == CONST_M3U)
        {
        	  setfont(smallfont);
			  gprintf("<List> ");
           //setfont(bigfont);
        }
        else

        {
           gprintf("%-03d ", playlist[i+j-PosBar].nr);
           setfont(smallfont);
        }
        if (i==PosBar)
        {
          setfont(bigfont);
        }
        gprintf("%s", playlist[i+j-PosBar].title);
      }
    }
    LCD_Update();
    RTX_Sleep_Time(100);
    if (kbhit())
    {
      BUF_Clear;
      return;
    }
    while (msgs.Count())
    {
      int key = msgs.Get();
      switch (key) {
        case VK_DIMMER:
           Brightness+=64;
           if (Brightness >= 256)
           {
             Brightness=0;
           }

           LCD_SetBrightness(Brightness);
           break;

		  // play
        case VK_PLAY:
          {
             int cont = 1;
             while (cont)
             {
               if (cont==1)
               {
                 if (playlist[currentSong].type==CONST_Dir)
                 {
                   getcwd(buffer,MAXPATH);
                   directory=strcat(buffer,playlist[currentSong].filename);
                   goto LoadDir;
                 }
                 if (playlist[currentSong].type==CONST_M3U)
                 {
                   getcwd(buffer,MAXPATH);
                   directory=strcat(buffer,playlist[currentSong].filename);
                   goto LoadDir;
                 }
               }
               cont = 2;
               iResult=PlaySong(playlist[currentSong].filename,currentSong);
               ini.WriteIni(INI_FILE);
               switch (iResult)
               {
                 case cOK:
                     if (iRepeat!=cRepeatOne)
                     {
                        do
                        {
                           currentSong++;
                           if (PosBar<3) PosBar++;
                           if (currentSong>numPlaylistEntries-1)
                           {
                            currentSong=0;
                            PosBar=0;
                             if (iRepeat!=cRepeatAll) cont = 0;
                           }
                        } while (playlist[currentSong].type == CONST_Dir);
                     }
                     break;
                 case cNext:
                     do
                     {
                        currentSong++;
                        if (PosBar>0) PosBar--;
                        if (PosBar<3) PosBar++;
                        if (currentSong>numPlaylistEntries-1)
                        {
                           PosBar=0;
                           currentSong=0;
                        }
							} while (playlist[currentSong].type == CONST_Dir);
                     break;
                 case cPrev:
                     do
                     {
                        currentSong--;
                        if (PosBar>0) PosBar--;
                        if (currentSong<0)
                        {
                           currentSong=numPlaylistEntries-1;
                           PosBar=3;
                           if (PosBar>numPlaylistEntries-1) PosBar=numPlaylistEntries-1;
                        }
                     } while (playlist[currentSong].type == CONST_Dir);
                     break;
                 case cReplay:
                    break;
                 case cStop:
                          cont = 0;
                          break;
                 default:
                          cont = 0;
                          break;
               };
               if (iResult>0)
               {
                  PosBar=0;
                  currentSong=0;

                  while ((playlist[currentSong].nr != iResult) &&
								 (currentSong<numPlaylistEntries))
                  {
                     currentSong++;
                     if (PosBar>0) PosBar--;
                     if (PosBar<3) PosBar++;
                  };
						msgs.Put(VK_PLAY);
					}
            }
          }
          break;

          case VK_STOP:  // Verzeichnis hher
          {
          	if ((numPlaylistEntries>0) && (strcmp("..",playlist[0].title)==0))
          	{
					msgs.Put(VK_FAST_REWIND);
               msgs.Put(VK_PLAY);
            }
            break;
          }

        //Next Title
        case VK_NEXT:

          if (currentSong<numPlaylistEntries-1)
          {
             currentSong++;
             if (PosBar<3) PosBar++;
          }
          break;

        //Previous Tittle
        case VK_PREV:

          if (currentSong>0)
          {
            currentSong--;
            if (PosBar>0) PosBar--;
          }
          break;

        //First Title
        case VK_FAST_REWIND:
          currentSong=0;
          PosBar=0;
          break;

		  //Last Title
        case VK_FAST_FORWARD:
          currentSong=numPlaylistEntries-1;
          PosBar=3;
          if (PosBar>numPlaylistEntries-1) PosBar=numPlaylistEntries-1;
          break;
        default:
        	printf("VK_KEY [%i] not supported", key);
          break;
      }
    }
  }
Exit:
}


int main(int argc, char* argv[])
{
 fstream fStream;
 string s;

  if (!CheckBIOS())
    return -1;

 ini.LoadIni(INI_FILE);
 vol=ini.ReadKeyI("SETTINGS","VOLUME",192);
 Brightness=ini.ReadKeyI("SETTINGS","BRIGHTNESS",255);

  SYS_SetSTDIOFocus(SYS_FOCUS_APP);
  printf("mp3 Player Version 0.99"
         "(c) 1999-2001 by thomas.kindler@gmx.de.\n"
         "(c) 2002 by Gerhard Steinwedel\n");

  initgraph();
  LCD_SetBrightness(Brightness);
  smallfont = loadfont("a:\\fnt4x6.fnt");
  bigfont   = loadfont("a:\\fnt6x6.fnt");
  setfont(smallfont);

  RC_Init();


  VS_Init();
  BUF_Init(16*1024, 128*1024L);

  if (argc == 2)
  {
    if (strcmp("/wr",argv[1])==0)
    {
      WebRadio();
    }
    else
    {
      PlaySong(argv[1],0);
    }
  }
  else
  {
    Songlist();
  }


  BUF_Done();
  VS_Done();

  RC_Done();
  closegraph();

  SYS_SetSTDIOFocus(SYS_FOCUS_BOTH);
  printf("done...\n");
  return 0;
}


void ReadDirectory(char *cDir)
{
	int done;
	struct ffblk ffblk;

   // In das neue Verzeichnis wechseln
	chdir(cDir);

	// Get Dirs
	done = findfirst("*.*", &ffblk, 0);
	while (!done && numPlaylistEntries<cPlaylistMaxEntries)  {
   	if (((ffblk.ff_attrib & _A_SUBDIR) == _A_SUBDIR) && (strcmp(".",ffblk.ff_name)!=0))
   	{
      	playlist[numPlaylistEntries].filename = strdup(ffblk.ff_name);
       	playlist[numPlaylistEntries].title = strdup(ffblk.ff_name);
       	playlist[numPlaylistEntries].type = CONST_Dir;
       	numPlaylistEntries++;
		}
    	done = findnext(&ffblk);
    	cleardevice();
    	moveto(0,0);
    	gprintf("%d files..", numPlaylistEntries);
    	LCD_Update();
	}

	// Get M3Us
	done = findfirst("*.m3u", &ffblk, 4);
	while (!done && numPlaylistEntries<cPlaylistMaxEntries)
	{
		playlist[numPlaylistEntries].filename = strdup(ffblk.ff_name);
   	playlist[numPlaylistEntries].title = strdup(ffblk.ff_name);
      playlist[numPlaylistEntries].type = CONST_M3U;
      numPlaylistEntries++;
	   done = findnext(&ffblk);
   	cleardevice();
	   moveto(0,0);
   	gprintf("%d files..", numPlaylistEntries);
	   LCD_Update();
   }

  // Get MP3s
  done = findfirst("*.mp3", &ffblk, 0);
  while (!done && numPlaylistEntries<cPlaylistMaxEntries)
  {
    playlist[numPlaylistEntries].nr = numSongs;
    playlist[numPlaylistEntries].filename = strdup(ffblk.ff_name);
 	 playlist[numPlaylistEntries].played = false;
    FILE *f = fopen(ffblk.ff_name, "rb");
    if (f) {
      ID3v1Tag  tag;
      if (ID3v1_ReadTag(f, &tag))
        playlist[numPlaylistEntries].title = strdup(tag.title);
      else
        playlist[numPlaylistEntries].title = strdup(ffblk.ff_name);
      fclose(f);
      playlist[numPlaylistEntries].type = CONST_MP3;
    } else{
      perror("");
    }
    numPlaylistEntries++;
    numSongs++;

    done = findnext(&ffblk);
    cleardevice();
    moveto(0,0);
    gprintf("%d files..", numPlaylistEntries);
    LCD_Update();
  }
}

void ReadM3U(char *filename)
{
	FILE *handle;

	//Eintrag um ein Verzeichnis hher zu wechseln einfgen
   playlist[numPlaylistEntries].filename = strdup(".");
   playlist[numPlaylistEntries].title = strdup("..");
   playlist[numPlaylistEntries].type = CONST_Dir;
   numPlaylistEntries++;

   char zeile[MAX_Zeilen_Laenge];
   if((handle = fopen(filename,"rb")) == NULL)
   {
      printf("\"%s\" konnte nicht geffnet werden!",filename);
      return;
   }
   while (!feof(handle))
   {
      if (fgets(zeile,MAX_Zeilen_Laenge,handle)!=NULL)
      {
         if (zeile[0]!='#')
         {
            if (zeile[strlen(zeile)-1]==10) zeile[strlen(zeile)-1]=0;
            if (zeile[strlen(zeile)-1]==13) zeile[strlen(zeile)-1]=0;
            FILE *f = fopen(zeile, "rb");
            if (f)
            {
               playlist[numPlaylistEntries].played = false;
               ID3v1Tag  tag;
               if (ID3v1_ReadTag(f, &tag))
                  playlist[numPlaylistEntries].title = strdup(tag.title);
               else
                  playlist[numPlaylistEntries].title = strdup(zeile);
               playlist[numPlaylistEntries].nr = numSongs;
               playlist[numPlaylistEntries].filename = strdup(zeile);
               playlist[numPlaylistEntries].type = CONST_MP3;
               numSongs++;
               numPlaylistEntries++;

               fclose(f);
            }
         }
		}
   }
   fclose(handle);

}

int IsM3U(char *cDir)
{
   //Achtung Routine beachtet nicht, da es sich um eine Dateiendeung handeln mu
   //Hat ein Verzeichnis eine Dateiendung mit m3u fllt Routine rein
	int result=0;
   if (strstr(cDir,".M3U")>0) result=1;
	return result;
}
